All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 [ -n "$VCSH_DEBUG" ] && set -x
4 [ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
5 [ -z "$VCSH_BASE" ] && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
8 if [ "$SELF" = 'bash' ] ||
9 [ "$SELF" = 'dash' ] ||
11 [ "$SELF" = 'zsh' ]; then
18 echo "usage: $SELF <args>
21 [<repo>] Clone from an existing repository
22 help Display this help text
23 delete Delete an existing repository
24 exit Exit repository; unset ENV
25 init <repo> Initialize a new repository
26 list List all repositories
28 <command> Use this repository
31 <repo> Seed .gitignore.d/<repo> from git ls-files
32 use <repo> Use repository; set ENV
34 <repo> <git command> Special command that allows you to run git commands
35 directly without having to type so much ;)" >&2
39 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
43 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
48 if [ ! -d "$GIT_DIR" ]; then
49 echo E: no repository found for "$VCSH_REPO_NAME" >&2
53 export GIT_WORK_TREE="$(git config --get core.worktree)"
54 export VCSH_DIRECTORY="$VCSH_REPO_NAME"
59 verbose "init() begin"
61 echo "$SELF: fatal: $GIT_DIR exists" &&
63 export GIT_WORK_TREE="$HOME"
64 mkdir -p "$GIT_WORK_TREE"
65 cd "$GIT_WORK_TREE" ||
66 (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
67 return 1) || return $?
70 git config core.worktree "$GIT_WORK_TREE"
71 git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
72 touch "$HOME/.gitignore.d/$VCSH_REPO_NAME"
73 git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
84 if [ "$1" = 'clone' ]; then
88 [ -z "$VCSH_REPO_NAME" ] && VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
90 export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
91 elif [ "$1" = 'delete' ] ||
94 [ "$1" = 'seed-gitignore' ] ||
95 [ "$1" = 'use' ]; then
96 [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
97 export VCSH_COMMAND="$1"
98 export VCSH_REPO_NAME="$2"
99 export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
101 export VCSH_EXTERNAL_COMMAND="$*"
102 if [ "$VCSH_COMMAND" = 'run' ]; then
103 [ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
105 elif [ "$1" = 'exit' ] ||
107 [ "$1" = 'list' ]; then
108 export VCSH_COMMAND="$1"
110 [ -z $1 ] && help && return 0
111 export VCSH_COMMAND='run'
112 export VCSH_REPO_NAME="$1"
113 export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
114 [ -d $GIT_DIR ] || (help && return 1) || return 0
116 export VCSH_EXTERNAL_COMMAND="git $*"
120 for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
122 if [ ! -d "$check_directory" ]; then
123 if [ -e "$check_directory" ]; then
124 echo "$SELF: error: $check_directory exists but is not a directory" >&2
127 echo "$SELF: info: attempting to create $check_directory"
128 mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; return 2) || return $?
134 if [ "$VCSH_COMMAND" = 'clone' ]; then
135 verbose "clone begin"
137 git remote add origin "$GIT_REMOTE"
138 git config branch.master.remote origin
139 git config branch.master.merge refs/heads/master
141 for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
143 echo "$SELF: error: $object exists." &&
146 [ "$VCSH_CONFLICT" = '1' ] &&
147 echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
148 echo " Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
150 git merge origin/master
154 #elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
155 elif [ "$VCSH_COMMAND" = 'help' ]; then
158 elif [ "$VCSH_COMMAND" = 'delete' ]; then
159 verbose "delete begin"
163 echo "$SELF: info: This operation WILL DETROY DATA!"
164 files=$(git ls-files)
165 echo "These files will be deleted:
169 AGAIN, THIS WILL DELETE YOUR DATA!
170 To continue, type \"Yes, do as I say\""
172 [ "x$answer" = "xYes, do as I say" ] || return 1
173 for file in $files; do
174 rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
176 rm -rf "$GIT_DIR" || echo "$SELF: info: could not delete '$GIT_DIR'"
180 elif [ "$VCSH_COMMAND" = 'exit' ]; then
182 # if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
183 # unset VCSH_NO_IGNORE_EOF
184 # setopt NO_IGNORE_EOF
186 [ -z "$VCSH_SOURCED" ] && echo "$SELF $VCSH_COMMAND: You need to source vcsh if you want to run in this mode" && return 10
188 # [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
192 elif [ "$VCSH_COMMAND" = 'init' ]; then
198 elif [ "$VCSH_COMMAND" = 'list' ]; then
200 for i in "$VCSH_BASE"/*.git; do
201 echo $(basename "$i" .git)
205 elif [ "$VCSH_COMMAND" = 'run' ]; then
208 $VCSH_EXTERNAL_COMMAND
212 elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
213 verbose "seed-gitignore begin"
215 # Switching directory as this has to be executed from $HOME to be of any use.
216 # Going back into old directory at the end in case `vcsh use` is reactivated.
219 git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
220 gitignores=$(for file in $(git ls-files); do
222 echo $file; new="${file%/*}"
223 [ "$file" = "$new" ] && break
227 tempfile=$(mktemp) ||
228 (echo "$SELF: fatal: could not create tempfile" && return 1) || return $?
229 echo '*' > "$tempfile"
230 for gitignore in $gitignores; do
231 echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
232 [ -d "$gitignore" ] && echo "$gitignore/*" | sed 's/^/!/'>> "$tempfile"
234 diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
237 if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
238 echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
239 mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
240 (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" &&
241 return 1) || return $?
243 mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
244 (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && return 1) || return $?
246 verbose "seed-gitignore end"
248 elif [ "$VCSH_COMMAND" = 'use' ]; then
250 # if [ -n "$ZSH_VERSION" ]; then
251 # if [ -o NO_IGNORE_EOF ]; then
252 # export VCSH_NO_IGNORE_EOF=1
260 # bindkey '^d' 'vcsh_exit'
262 [ -z "$VCSH_SOURCED" ] && echo "$SELF $VCSH_COMMAND: You need to source vcsh if you want to run in this mode" && return 10
264 # [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
268 verbose "defaulting to calling help()"
270 echo "$SELF: fatal: You should never reach this code. File a bug, please."